#include <ba_config.h>
#include <ba_sim.h>

struct ba_id_gen_s {
    ba_id_t next_id;
};

extern ba_id_t
ba_id_gen_next(ba_id_gen_t *id_gen)
{
    BA_ASSERT(id_gen);
    ba_id_t next_id;

    next_id = id_gen->next_id;

    id_gen->next_id++;
    BA_ASSERT(id_gen->next_id < UINT32_MAX);

    return next_id;
}

extern ba_id_gen_t *
ba_id_gen_new(void)
{
    ba_id_gen_t *id_gen;

    id_gen = ba_mem_malloc(sizeof(ba_id_gen_t));
    id_gen->next_id = 0;

    return id_gen;
}

extern void
ba_id_gen_delete(ba_id_gen_t *id_gen)
{
    BA_ASSERT(id_gen);

    ba_mem_free(id_gen);
}
