#ifndef __BA_PRINT_H__
#define __BA_PRINT_H__

#include <ba_config.h>
#include <ba_status.h>

/* this is defn'd in ba_types.h.  :(  see the comment there.  XXX
   typedef void (ba_print_func_t)(const char *fmt, ...); */

extern ba_print_func_t ba_print_info;
extern ba_print_func_t ba_print_data;
extern ba_print_func_t ba_print_error;

extern ba_print_func_t ba_print_write_trace_output;

extern ba_bool ba_print_read_trace_input_line(char *str_out,
					      uint32_t str_len,
					      ba_bool omit_extra);

extern void ba_print_flush_info(void);
extern void ba_print_flush_data(void);
extern void ba_print_flush_error(void);

extern void ba_print_flush_trace_output(void);

extern ba_status ba_print_init(void);
extern ba_status ba_print_destroy(void);
extern void ba_print_destroy_from_hook(void *unused);

#endif /* !__BA_PRINT_H__ */
