#!/usr/bin/perl -w

use strict;

# copied from ba_present
my $matlab_ratio = 0.75;
my $inverse_golden_ratio = (1 / 1.61803399);
my $font_size = 9;
my $image_length = 3.25;
my $image_height = $image_length * $matlab_ratio;
my $axis_length_offset = 0.75;
my $axis_height_offset = $axis_length_offset * $matlab_ratio;
my $marker_size = 5;

my (@lines, @orig_lines);
my $total_wanted;

while(<STDIN>) {
    chop;
    last if /^----/;

    push @orig_lines, $_;
}

if($ARGV[0]) {
    $total_wanted = $ARGV[0];
    die "wanted too many lines" if($total_wanted > @orig_lines);
} else {
    $total_wanted = @orig_lines;
}

my $i = 1;
foreach my $line (@orig_lines) {
    push @lines, $line if($i % (@orig_lines / $total_wanted) == 0);
    $i++;
}

#print "num in orig: " . scalar @orig_lines . ", num in new: " .
#    scalar @lines . "\n";
#foreach my $line (@lines) {
#    print $line . "\n";
#}
#die;

my ($x_str, $y_str);
my $first = 1;

$x_str = "x = [";
$y_str = "y = [";

foreach my $line (@lines) {
    my ($x, $y);

    if($line =~ /^([^ ]+) ([^ ]+)$/) {
	($x, $y) = ($1, $2);
    } else {
	die;
    }

    if($first) {
	$first = 0;
    } else {
	$x_str .= ",";
	$y_str .= ",";
    }

    $x_str .= $x;
    $y_str .= $y;
}
$x_str .= "];\n";
$y_str .= "];\n";

print $x_str;
print $y_str;

my ($axis_length_end, $axis_height_end);

$axis_length_end = $image_length - $axis_length_offset;
$axis_height_end = $image_height - $axis_height_offset;

print "figure;\n";
print "set(gca,'FontSize',$font_size);\n";
print "set(gca,'Units','inches');\n";
print "set(gca,'Position',[$axis_length_offset $axis_height_offset " .
    "$axis_length_end $axis_height_end]);\n";
print "plot(x,y);\n";
print "xlabel('time','FontSize',$font_size)\n";
print "ylabel('queue length','FontSize',$font_size)\n";
print "box off;\n";
print "set(gcf,'PaperPosition',[0 0 $image_length $image_height]);\n";
