#ifndef __BA_SCHED_H__
#define __BA_SCHED_H__

#include <ba_config.h>

typedef enum {
    BA_SCHED_BEHAVIOR_FCFS = 0,
    BA_SCHED_BEHAVIOR_RFCFS,
    BA_SCHED_BEHAVIOR_PS,
    BA_SCHED_BEHAVIOR_UFB,
    BA_SCHED_BEHAVIOR_URFB,
    BA_SCHED_BEHAVIOR_DUFB,
    BA_SCHED_BEHAVIOR_GSVSD,
    BA_SCHED_BEHAVIOR_SRPT,
    BA_SCHED_BEHAVIOR_RSRPT,
    BA_SCHED_BEHAVIOR_HRP,
    BA_SCHED_BEHAVIOR_HRR,
    BA_SCHED_BEHAVIOR_EDF,
    BA_SCHED_BEHAVIOR_LPRT,
    BA_SCHED_BEHAVIOR_LPRTP,
    BA_SCHED_BEHAVIOR_RAND,
    BA_SCHED_BEHAVIOR_RANDU,
    BA_SCHED_BEHAVIOR_NOOP,
    BA_SCHED_BEHAVIOR_UNKNOWN,
} ba_sched_behavior_t;

extern void ba_sched_candidates_print(void);

extern void ba_sched_choose(void);
extern ba_sched_behavior_t ba_sched_str_to_sched_behavior(char *str);
extern void ba_sched_behavior_print_short_to(ba_sched_behavior_t behavior,
					     ba_print_func_t *print_func);
extern void ba_sched_behavior_print_short(ba_sched_behavior_t behavior);
extern ba_status ba_sched_init(void);
extern ba_status ba_sched_destroy(void);
extern void ba_sched_destroy_from_hook(void *unused);

#endif /* !__BA_SCHED_H__ */
