#ifndef __BA_TASK_H__
#define __BA_TASK_H__

#include <ba_config.h>

typedef struct ba_task_s ba_task_t;

struct ba_task_set_s;

extern ba_id_t ba_task_id_get(ba_task_t *task);
extern void ba_task_counted_in_warmup_set(ba_task_t *task,
				     ba_real completed_before_warmup,
					  ba_real st_after_warmup);
extern ba_bool ba_task_counted_in_warmup_get(ba_task_t *task,
				     ba_real *completed_before_warmup_out,
					     ba_real *st_after_warmup_out);
extern void ba_task_service_delta_time_set(ba_task_t *task,
					   ba_real service_delta_time);
extern void ba_task_think_delta_time_set(ba_task_t *task,
					 ba_real think_delta_time);
extern void ba_task_will_be_requested_set(ba_task_t *task,
					  ba_bool will_be_requested);
extern ba_bool ba_task_running_get(ba_task_t *task);
extern void ba_task_running_set(ba_task_t *task);
extern void ba_task_running_unset(ba_task_t *task);

extern ba_bool ba_task_disclosed_get(ba_task_t *task);
extern ba_bool ba_task_executed_get(ba_task_t *task);
extern ba_bool ba_task_requested_get(ba_task_t *task);
extern ba_bool ba_task_finished_get(ba_task_t *task);
extern ba_bool ba_task_canceled_get(ba_task_t *task);

extern void ba_task_disclosed_abs_time_set(ba_task_t *task,
					  ba_real disclosed_abs_time);
extern void ba_task_executed_abs_time_set(ba_task_t *task,
					  ba_real executed_abs_time);
extern void ba_task_requested_abs_time_set(ba_task_t *task,
					   ba_real requested_abs_time);
extern void ba_task_finished_abs_time_set(ba_task_t *task,
					   ba_real finished_abs_time);
extern void ba_task_canceled_abs_time_set(ba_task_t *task,
					 ba_real canceled_abs_time);

extern ba_real ba_task_disclosed_abs_time_get(ba_task_t *task);
extern ba_real ba_task_executed_abs_time_get(ba_task_t *task);
extern ba_real ba_task_requested_abs_time_get(ba_task_t *task);
extern ba_real ba_task_finished_abs_time_get(ba_task_t *task);
extern ba_real ba_task_canceled_abs_time_get(ba_task_t *task);

extern struct ba_task_set_s *ba_task_task_set_get(ba_task_t *task);
extern ba_user_t *ba_task_user_get(ba_task_t *task);

extern ba_real ba_task_remaining_delta_time_get(ba_task_t *task);
extern void ba_task_add_completed_delta_time(ba_task_t *task,
					     ba_real add_completed_delta_time);
extern void ba_task_add_completed_warmup_delta_time(ba_task_t *task,
				    ba_real add_completed_warmup_delta_time);
extern ba_real ba_task_completed_delta_time_get(ba_task_t *task);
extern ba_real ba_task_completed_warmup_delta_time_get(ba_task_t *task);
extern ba_real ba_task_service_delta_time_get(ba_task_t *task);
extern ba_real ba_task_think_delta_time_get(ba_task_t *task);
extern ba_real ba_task_will_be_requested_get(ba_task_t *task);

extern void ba_task_print(ba_task_t *task);
extern void ba_task_print_from_list(void *task_in,
				    void *unused);

extern ba_task_t *ba_task_clone_new_from_old(ba_task_t *task_old,
					     struct ba_task_set_s *task_set);
extern ba_task_t *ba_task_new(ba_id_t id,
			      struct ba_task_set_s *task_set);
extern void ba_task_delete(ba_task_t *task);
extern void ba_task_delete_from_list(void *task_in,
				     void *unused);

#endif /* !__BA_TASK_H__ */
