#ifndef __BA_TIME_PERIOD_H__
#define __BA_TIME_PERIOD_H__

#include <ba_config.h>

typedef struct ba_time_period_s ba_time_period_t;

extern ba_bool ba_time_period_is_equal(ba_time_period_t *a_time_period,
				       ba_time_period_t *b_time_period);
extern ba_real ba_time_period_start_abs_time_get(ba_time_period_t
						 *time_period);
extern ba_real ba_time_period_end_abs_time_get(ba_time_period_t
					       *time_period);
extern ba_real ba_time_period_delta_time(ba_time_period_t *time_period);
extern void ba_time_period_print(ba_time_period_t *time_period);
extern void ba_time_period_print_from_list(void *time_period_in,
					   void *unused);
extern ba_time_period_t *ba_time_period_copy(ba_time_period_t
					     *time_period_src);
extern ba_time_period_t *ba_time_period_new(ba_real start_abs_time,
					    ba_real end_abs_time);
extern void ba_time_period_delete(ba_time_period_t *time_period);
extern void ba_time_period_delete_from_list(void *time_period_in,
					    void *unused);

#endif /* !__BA_TIME_PERIOD_H__ */
