#include <ba_config.h>
#include <ba_sim.h>

extern void
ba_types_bool_print_to(ba_bool val,
		       ba_print_func_t *print_func)
{
    BA_ASSERT(print_func);

    if(val) {
	print_func("BA_TRUE");
    } else {
	print_func("BA_FALSE");
    }
}

extern void
ba_types_bool_print(ba_bool val)
{
    ba_types_bool_print_to(val, ba_print_info);
}

extern ba_bool
ba_types_real_greater_than_or_equal(ba_real a,
				    ba_real b)
{
    if(a >= b - BA_REAL_TOLERANCE) {
	return BA_TRUE;
    } else {
	return BA_FALSE;
    }
}

extern ba_bool
ba_types_real_less_than_or_equal(ba_real a,
				 ba_real b)
{
    if(a <= b + BA_REAL_TOLERANCE) {
	return BA_TRUE;
    } else {
	return BA_FALSE;
    }
}

extern ba_bool
ba_types_real_equal(ba_real a,
		    ba_real b)
{
    if(a <= b + BA_REAL_TOLERANCE &&
       a >= b - BA_REAL_TOLERANCE) {
	return BA_TRUE;
    } else {
	return BA_FALSE;
    }
}
