#ifndef __BA_TYPES_H__
#define __BA_TYPES_H__

#include <ba_config.h>
#include <stdint.h>

// ba_bool

typedef char ba_bool;

#define BA_FALSE 0
#define BA_TRUE !BA_FALSE

// XXX the typedef repeated from ba_print.h.  unless i introduce an
// auxiliary include file, i need to do this.  this is because
// ba_types.h and ba_print.h need typedefs from each other.
typedef void (ba_print_func_t)(const char *fmt, ...);
extern void ba_types_bool_print_to(ba_bool val,
				   ba_print_func_t *print_func);
extern void ba_types_bool_print(ba_bool val);

// ba_real

typedef double ba_real;

#define BA_REAL_FMT "%.6f"
#define BA_REAL_LOW_PREC_FMT "%.3f"
#define BA_REAL_HIGH_PREC_FMT "%.12f"

#define BA_REAL_SCAN_FMT "%lf"

#define BA_REAL_TOLERANCE 1e-6

#define BA_REAL_MAX(_a_, _b_) \
    (((_a_) > (_b_)) ? (_a_) : (_b_))

#define BA_REAL_MIN(_a_, _b_) \
    (((_a_) < (_b_)) ? (_a_) : (_b_))

extern ba_bool ba_types_real_greater_than_or_equal(ba_real a,
						   ba_real b);
extern ba_bool ba_types_real_less_than_or_equal(ba_real a,
						ba_real b);
extern ba_bool ba_types_real_equal(ba_real a,
				   ba_real b);

#endif /* !__BA_TYPES_H__ */
