#ifndef __BA_USER_H__
#define __BA_USER_H__

#include <ba_config.h>

typedef struct ba_user_s ba_user_t;
struct ba_task_s;

extern ba_real ba_user_request_probability_get(ba_user_t *user);
extern void ba_user_queue_for_destruction(ba_user_t *user);
extern ba_real ba_user_task_set_change_prob_get(ba_user_t *user);
extern GSList *ba_user_requested_tasks_get(ba_user_t *user);
extern GSList *ba_user_disclosed_tasks_get(ba_user_t *user);
extern ba_real ba_user_total_vsd_get(ba_user_t *user);
extern ba_real ba_user_total_vrt_delta_time_get(ba_user_t *user);
extern ba_id_t ba_user_id_get(ba_user_t *user);
extern ba_bool ba_user_stop_running_tasks_get(ba_user_t *user);
extern ba_real ba_user_stop_running_tasks_abs_time_get(ba_user_t *user);
extern ba_id_t ba_user_task_id_next(ba_user_t *user);
extern struct ba_task_set_s *ba_user_task_set_get(ba_user_t *user);
extern void ba_user_print(ba_user_t *user);
extern void ba_user_print_from_list(void *user_in,
				    void *unused);
extern ba_event_callback_t ba_user_activate_new_task_set;
extern void ba_user_deactivate_task_set(ba_user_t *user);
extern void ba_user_add_resource_usage(ba_user_t *user,
				       ba_real resource_usage,
				       ba_real start_abs_time,
				       ba_real end_abs_time,
				       struct ba_task_s *task);
extern ba_real ba_user_resource_total_usage_get(ba_user_t *user);
extern ba_real ba_user_req_resource_total_usage_get(ba_user_t *user);
extern ba_real ba_user_running_req_resource_total_usage_get(ba_user_t *user);
extern ba_bool ba_user_can_req_or_dis(ba_user_t *user,
				      ba_bool will_request);
extern ba_bool ba_user_can_exe(ba_user_t *user);
extern void ba_user_add_disclosed_task(ba_user_t *user,
				       struct ba_task_s *task);
extern void ba_user_add_executed_task(ba_user_t *user,
				      struct ba_task_s *task);
extern ba_user_t *ba_user_new(ba_id_t id);
extern void ba_user_delete(ba_user_t *user);
extern void ba_user_delete_from_list(void *user_in,
				     void *unused);

extern ba_status ba_user_init(void);
extern ba_status ba_user_destroy(void);
extern void ba_user_destroy_from_hook(void *unused);

#endif /* !__BA_USER_H__ */
